Index: drivers/s390/block/dasd.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/s390/block/dasd.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/s390/block/dasd.c	22 Jul 2004 19:49:59 -0000	1.1
+++ drivers/s390/block/dasd.c	4 Aug 2004 01:29:28 -0000	1.2
@@ -1685,65 +2109,60 @@
 	} /* end while over completed requests */
 
 	if (cqr)
-		cqr->next = NULL;
+		cqr->next = NULL;         /* terminate final_requests queue */
+
 	/* Now clean the requests with final status */
 	while (final_requests) { 
 		temp = final_requests;
 		final_requests = temp->next;
 		dasd_finalize_request (temp);
 	}
+
 	/* Now we try to fetch requests from the request queue */
-	for (temp = cqr; temp != NULL; temp = temp->next)
+	for (temp = qp->head; temp != NULL; temp = temp->next) {
 		if (temp->status == CQR_STATUS_QUEUED)
 			chanq_max_size--;
+        }
+
 	while ((atomic_read(&device->plugged) == 0) &&
+               (queue) &&
                (!queue->plugged) &&
 	       (!list_empty (&queue->queue_head)) &&
-	       (req = dasd_next_request (queue)) != NULL) {
+	       (req = dasd_next_request (queue)) &&
+               (qp->head == NULL || chanq_max_size > 0)) {
 		/* queue empty or certain critera fulfilled -> transfer */
-		if (qp->head == NULL ||
-		    chanq_max_size > 0 || (req->nr_sectors >= chanq_min_size)) {
-			ccw_req_t *cqr = NULL;
-                        if (is_read_only(device->kdev) && req->cmd == WRITE) {
-
-                                DASD_DRIVER_DEBUG_EVENT (3, dasd_int_handler,
-                                                         "(%04x) Rejecting write request %p\n",
-                                                         device->devinfo.devno,
-                                                         req);
+                cqr = NULL;
+                if (is_read_only(device->kdev) && req->cmd == WRITE) {
 
-                                dasd_end_request (req, 0);
-                                dasd_dequeue_request (queue,req);
-                        } else {
-                            /* relocate request according to partition table */
-                            req->sector +=
-                                device->major_info->gendisk.
-                                part[MINOR (req->rq_dev)].start_sect;
-                            cqr = device->discipline->build_cp_from_req (device, req);
-                            if (cqr == NULL) {
-
-                                    DASD_DRIVER_DEBUG_EVENT (3, dasd_int_handler,
-                                                             "(%04x) CCW creation failed "
-                                                             "on request %p\n",
-                                                             device->devinfo.devno,
-                                                             req);
-                                    /* revert relocation of request */
-                                    req->sector -=
-                                        device->major_info->gendisk.
-                                        part[MINOR (req->rq_dev)].start_sect;
-                                    break;	/* terminate request queue loop */
-                                    
-                            }
-#ifdef CONFIG_DYNAMIC_QUEUE_MIN_SIZE
-                            chanq_min_size =
-                                (chanq_min_size + req->nr_sectors) >> 1;
-#endif				/* CONFIG_DYNAMIC_QUEUE_MIN_SIZE */
-                            dasd_dequeue_request (queue, req);
-                            dasd_chanq_enq (qp, cqr);
+                        DBF_EVENT (DBF_ERR,
+                                   "(%04x) Rejecting write request %p",
+                                   device->devinfo.devno,
+                                   req);
+                        dasd_dequeue_request (queue,req);
+                        dasd_end_request (req, 0);
+                        continue;
+                } 
+                cqr = device->discipline->build_cp_from_req (device, req);
+                        
+                if (cqr == NULL || IS_ERR(cqr)) {
+                        if (cqr == ERR_PTR(-ENOMEM)) {
+                                break;
                         }
-		} else {	/* queue not empty OR criteria not met */
-			break;	/* terminate request queue loop */
-		}
+
+                        MESSAGE (KERN_EMERG,
+                                 "(%04x) CCW creation failed "
+                                 "on request %p",
+                                 device->devinfo.devno, req);
+                        dasd_dequeue_request (queue,req);
+                        dasd_end_request (req, 0);
+                        continue;
+                }
+                dasd_dequeue_request (queue, req);
+                dasd_chanq_enq (qp, cqr);
+                chanq_max_size--;
+
 	}
+
 	/* we process the requests with non-final status */
 	if (qp->head) {
 		switch (qp->head->status) {
@@ -1759,11 +2178,11 @@
 				/* to be filled with MIH */
 			}
 			break;
-
-		case CQR_STATUS_PENDING:
-			/* just wait */
-			break;
 		default:
+                        MESSAGE (KERN_EMERG,
+                                 "invalid cqr (%p) detected with status %02x ",
+                                 qp->head,
+                                 qp->head->status);
 			BUG ();
 		}
 	}
@@ -1786,6 +2205,18 @@
 }
 
 /*
+ * function dasd_schedule_bh_timed
+ * retriggers the dasd_schedule_bh function (called by timer queue)
+ */
+void 
+dasd_schedule_bh_timed (unsigned long device_ptr)
+{
+        dasd_device_t *device = (dasd_device_t *) device_ptr;
+
+        dasd_schedule_bh (device);
+}
+
+/*
  * function dasd_schedule_bh
  * schedules the request_fn to run with next run_bh cycle
  */
@@ -1820,53 +2251,43 @@
 }
 
 /*
- * DASD_HANDLE_STATE_CHANGE_PENDING
+ * function dasd_handle_state_change_pending
  *
- * DESCRIPTION
- *   Handles the state change pending interrupt.
- *   Search for the device related request queue and check if the first
- *   cqr in queue in in status 'CQR_STATUE_PENDING'.
- *   If so the status is set to 'CQR_STATUS_QUEUED' to reactivate
- *   the device.
- *
- *  PARAMETER
- *   stat               device status of state change pending interrupt.
+ * handles the state change pending interrupt.
  */
 void
 dasd_handle_state_change_pending (devstat_t * stat)
 {
-	dasd_device_t **device_addr;
+
+	dasd_device_t **device_addr, *device;
 	ccw_req_t *cqr;
 
 	device_addr = dasd_device_from_devno (stat->devno);
 
-	if (device_addr == NULL) {
-
-		printk (KERN_DEBUG PRINTK_HEADER
-			"unable to find device for state change pending "
-			"interrupt: devno%04x\n", 
-                        stat->devno);
+	if (!device_addr) 
                 return;
-	} 
 
-        /* re-activate first request in queue */
-        cqr = (*device_addr)->queue.head;
+        device = *device_addr;
+	if (!device) 
+                return;
         
-        if (cqr->status == CQR_STATUS_PENDING) {
-                
-                DASD_MESSAGE (KERN_DEBUG, (*device_addr), "%s",
-                              "device request queue restarted by "
-                              "state change pending interrupt\n");
-                
-                del_timer (&(*device_addr)->timer);
-                
-                check_then_set (&cqr->status,
-                                CQR_STATUS_PENDING, CQR_STATUS_QUEUED);
-                
-                dasd_schedule_bh (*device_addr);
-                
+        /* restart all 'running' IO on queue */
+        cqr = device->queue.head;
+        while (cqr) {
+                if (cqr->status == CQR_STATUS_IN_IO) {
+                        cqr->status = CQR_STATUS_QUEUED;
+                }
+                cqr = cqr->next;
         }
 
+        DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                     "device request queue restarted by "
+                     "state change pending interrupt");
+        
+        del_timer_sync (&(device->blocking_timer));
+        device->stopped &= ~DASD_STOPPED_PENDING;
+        dasd_schedule_bh (device);
+
 } /* end dasd_handle_state_change_pending */
 
 /*
@@ -1879,50 +2300,50 @@
 	int ip;
 	ccw_req_t *cqr;
 	dasd_device_t *device;
-        unsigned long long now;
-	dasd_era_t era = dasd_era_none; /* default is everything is okay */
+	dasd_era_t era;
 	devstat_t *stat = (devstat_t *)ds;
 
         if (stat == NULL) {
                 BUG();
 	}
-        DASD_DRIVER_DEBUG_EVENT (6, dasd_int_handler,
-                                 "Interrupt: IRQ %02x, stat %02x, devno %04x",
-                                 irq,
-                                 stat->dstat,
-                                 stat->devno);
-        asm volatile ("STCK %0":"=m" (now));
+
+        DBF_EVENT (DBF_DEBUG,
+                   "Int: IRQ %02x, CS/DS %04x, flag %08x, devno %04x, ip %08x",
+                   irq,
+                   ((stat->cstat<<8)|stat->dstat),
+                   stat->flag,
+                   stat->devno,
+                   stat->intparm);
 
         /* first of all check for state change pending interrupt */
         if ((stat->dstat & DEV_STAT_ATTENTION ) && 
             (stat->dstat & DEV_STAT_DEV_END   ) &&
             (stat->dstat & DEV_STAT_UNIT_EXCEP)   ) {
-                DASD_DRIVER_DEBUG_EVENT (2, dasd_int_handler,
-                                         "State change Interrupt: %04x",
-                                         stat->devno);
+
+                DBF_EVENT (DBF_NOTICE,
+                           "State change Interrupt: %04x",
+                           stat->devno);
+
                 dasd_handle_state_change_pending (stat);
                 return;
         }
 
 	ip = stat->intparm;
 	if (!ip) {		/* no intparm: unsolicited interrupt */
-                DASD_DRIVER_DEBUG_EVENT (2, dasd_int_handler,
-                                         "Unsolicited Interrupt: %04x",
-                                         stat->devno);
-		printk (KERN_DEBUG PRINTK_HEADER
-                        "unsolicited interrupt: irq 0x%x devno %04x\n",
-                        irq,
-                        stat->devno);
+
+		MESSAGE (KERN_DEBUG,
+                         "unsolicited interrupt: irq 0x%x devno %04x",
+                         irq,
+                         stat->devno);
 		return;
 	}
-	if (ip & 0x80000001) {
-                DASD_DRIVER_DEBUG_EVENT (2, dasd_int_handler,
-                                         "spurious Interrupt: %04x",
-                                         stat->devno);
-		printk (KERN_DEBUG PRINTK_HEADER
-                        "spurious interrupt: irq 0x%x devno %04x, parm %08x\n",
-                        irq,
-                        stat->devno,ip);
+
+	if (ip & 0x80000001) {  /* check for invalid 'cqr' address */
+
+		MESSAGE (KERN_DEBUG,
+                         "spurious interrupt: irq 0x%x devno %04x, parm %08x",
+                         irq,
+                         stat->devno,ip);
 		return;
 	}
 
@@ -1930,19 +2351,16 @@
 
         /* check status - the request might have been killed because of dyn dettach */
 	if (cqr->status != CQR_STATUS_IN_IO) {
-                DASD_DRIVER_DEBUG_EVENT (2, dasd_int_handler,
-                                         "invalid status %02x on device %04x",
-                                         cqr->status,
-                                         stat->devno);
-
-		printk (KERN_DEBUG PRINTK_HEADER
-                        "invalid status: irq 0x%x devno %04x, status %02x\n",
-                        irq,
-                        stat->devno,
-                        cqr->status);
+
+		MESSAGE (KERN_DEBUG,
+                         "invalid status: irq 0x%x devno %04x, status %02x",
+                         irq,
+                         stat->devno,
+                         cqr->status);
 		return;
 	}
 
+        /* some consistency checks */
 	device = (dasd_device_t *) cqr->device;
 	if (device == NULL || 
             device != ds-offsetof(dasd_device_t,dev_status)) {
@@ -1955,73 +2373,98 @@
                 BUG();
 	}
 
-        /* first of all lets try to find out the appropriate era_action */
-        DASD_DEVICE_DEBUG_EVENT (4, device," Int: CS/DS 0x%04x",
-                                 ((stat->cstat<<8)|stat->dstat));
-
 	/* first of all lets try to find out the appropriate era_action */
-	if (stat->flag & DEVSTAT_FLAG_SENSE_AVAIL ||
-	    stat->dstat & ~(DEV_STAT_CHN_END | DEV_STAT_DEV_END)) {
-		/* anything abnormal ? */
-		if (device->discipline->examine_error == NULL ||
-		    stat->flag & DEVSTAT_HALT_FUNCTION) {
-			era = dasd_era_fatal;
-		} else {
-			era = device->discipline->examine_error (cqr, stat);
-		}
-                DASD_DRIVER_DEBUG_EVENT (1, dasd_int_handler," era_code %d",
-                                         era);
-	}
-        if ( era == dasd_era_none ) {
-                check_then_set(&cqr->status, 
-                               CQR_STATUS_IN_IO, 
-                               CQR_STATUS_DONE);
-
-                cqr->stopclk=now;
-		/* start the next queued request if possible -> fast_io */
-                if (cqr->next &&
-                    cqr->next->status == CQR_STATUS_QUEUED) {
-                        if (device->discipline->start_IO (cqr->next) != 0) {
-                                printk (KERN_WARNING PRINTK_HEADER
-                                        "Interrupt fastpath failed!\n");
-                        } 
-                }
-        } else { /* error */
+        if (stat->flag & DEVSTAT_HALT_FUNCTION) {
+                era = dasd_era_fatal;
+                
+	} else if (stat->flag  & DEVSTAT_FINAL_STATUS &&
+                   stat->dstat == (DEV_STAT_CHN_END | DEV_STAT_DEV_END) &&
+                   stat->cstat == 0) {
+		/* received 'ok' for running IO */
+		era = dasd_era_none;
+                
+        } else if (stat->flag & DEVSTAT_FLAG_SENSE_AVAIL) {
+                /* got sense data */
 		if (cqr->dstat == NULL)
 			cqr->dstat = kmalloc (sizeof (devstat_t), GFP_ATOMIC);
 		if (cqr->dstat) {
 			memcpy (cqr->dstat, stat, sizeof (devstat_t));
 		} else {
-			PRINT_ERR ("no memory for dstat...ignoring\n");
+			MESSAGE (KERN_DEBUG, "%s",
+                                 "no memory for dstat...ignoring");
 		}
-
 #ifdef ERP_DEBUG
-		/* dump sense data */
-		if (device->discipline            && 
+		if (device->discipline            &&
                     device->discipline->dump_sense  ) {
-
+                        
                         device->discipline->dump_sense (device, 
                                                         cqr);
 		}
 #endif
+                if (device->discipline->examine_error == NULL) {
+                        era = dasd_era_recover;
+                } else {
+                        era = device->discipline->examine_error (cqr, stat);
+                }
 
-		switch (era) {
-		case dasd_era_fatal:
-			check_then_set (&cqr->status, 
-                                        CQR_STATUS_IN_IO,
-					CQR_STATUS_FAILED);
+        } else  if (stat->flag & DEVSTAT_NOT_OPER) {
+                /* path became offline or similar                          */
+                /* => retry to see if there are any other pathes available */
+                DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                             "Device or a path became not operational while in IO");
+		era = dasd_era_recover;
+
+        } else if (stat->dstat & ~(DEV_STAT_CHN_END | DEV_STAT_DEV_END) ||
+                   stat->cstat & ~(SCHN_STAT_PCI | SCHN_STAT_INCORR_LEN) ) {
+                /* received device state apart from (channel end & device end)  */
+                /* OR any kind of channel check (e.g. IFCC, DATA_CHECK or ..... */
+                /* we got no sense data, therefore we just retry                */
+                DEV_MESSAGE (KERN_DEBUG, device,
+                             "Status without sense (IFCC,...) CS/DS %04x flag %08x",
+			     ((stat->cstat<<8)|stat->dstat),
+			     stat->flag);
+		era = dasd_era_recover;
 
-                        cqr->stopclk = now;
-			break;
-		case dasd_era_recover:
-			check_then_set (&cqr->status, 
-                                        CQR_STATUS_IN_IO,
-					CQR_STATUS_ERROR);
-			break;
-		default:
-			BUG ();
+        } else {
+                /* any other kind of interrupt  - just retry */
+                DEV_MESSAGE (KERN_DEBUG, device,
+                             "Got unclassified interrupt CS/DS %04x flag %08x",
+                             ((stat->cstat<<8)|stat->dstat),
+                             stat->flag);
+                era = dasd_era_recover;
+        }
+        
+        switch (era) {
+        case dasd_era_none:
+		check_then_set(&cqr->status, 
+			       CQR_STATUS_IN_IO, 
+			       CQR_STATUS_DONE);
+		cqr->stopclk = get_clock ();
+		/* start the next queued request if possible -> fast_io */
+		if (cqr->next &&
+		    cqr->next->status == CQR_STATUS_QUEUED) {
+			if (device->discipline->start_IO (cqr->next) != 0) {
+				MESSAGE (KERN_WARNING, "%s",
+					 "Interrupt fastpath failed!");
+			} 
 		}
-	}
+		break;
+        case dasd_era_fatal:
+		check_then_set (&cqr->status, 
+				CQR_STATUS_IN_IO,
+				CQR_STATUS_FAILED);
+		cqr->stopclk = get_clock ();
+		break;
+        case dasd_era_recover:
+		check_then_set (&cqr->status, 
+				CQR_STATUS_IN_IO,
+				CQR_STATUS_ERROR);
+		break;
+        default:
+		BUG ();
+        }
+	
+	/* handle special device initialization request */
         if ( cqr == device->init_cqr &&
              ( cqr->status == CQR_STATUS_DONE ||
                cqr->status == CQR_STATUS_FAILED )){
@@ -2033,59 +2476,47 @@
 
 } /* end dasd_int_handler */
 
-/* SECTION: Some stuff related to error recovery */
+/********************************************************************************
+ * SECTION: Some stuff related to error recovery 
+ ********************************************************************************/
 
 /*
  * DEFAULT_ERP_ACTION
  *
  * DESCRIPTION
- *   sets up the default-ERP ccw_req_t, namely one, which performs a TIC
- *   to the original channel program with a retry counter of 16
+ *   just retries the current cqr
  *
  * PARAMETER
  *   cqr                failed CQR
  *
  * RETURN VALUES
- *   erp                CQR performing the ERP
+ *   cqr                modified CQR
  */
 ccw_req_t *
 dasd_default_erp_action (ccw_req_t * cqr)
 {
 
         dasd_device_t *device = cqr->device;
-	ccw_req_t     *erp    = dasd_alloc_request ((char *) &cqr->magic, 1, 0, cqr->device);
-
-	printk (KERN_DEBUG PRINTK_HEADER "Default ERP called... \n");
-
-	if (!erp) {
-
-                DASD_MESSAGE (KERN_ERR, device, "%s",
-                              "Unable to allocate ERP request");
-                
+        // just retry - there is nothing to save ... I got no sense data....
+        if (cqr->retries > 0) {
+                DEV_MESSAGE (KERN_DEBUG, device, 
+                             "default ERP called (%i retries left)",
+                             cqr->retries);
+ 
                 check_then_set (&cqr->status,
                                 CQR_STATUS_ERROR,
-                                CQR_STATUS_FAILED);
-
-                asm volatile ("STCK %0":"=m" (cqr->stopclk));
-
-                return cqr;
-	}
-
-	erp->cpaddr->cmd_code = CCW_CMD_TIC;
-	erp->cpaddr->cda = (__u32) (addr_t) cqr->cpaddr;
-	erp->function = dasd_default_erp_action;
-	erp->refers = cqr;
-	erp->device = cqr->device;
-	erp->magic = cqr->magic;
-	erp->retries = 16;
-
-	erp->status = CQR_STATUS_FILLED;
-
-        dasd_chanq_enq_head (&device->queue,
-                             erp);
-
-	return erp;
-
+                                CQR_STATUS_QUEUED);
+        } else {
+                DEV_MESSAGE (KERN_WARNING, device, "%s",
+			     "default ERP called (NO retry left)");
+		
+		check_then_set (&cqr->status,
+				CQR_STATUS_ERROR,
+				CQR_STATUS_FAILED);
+		
+		cqr->stopclk = get_clock ();
+        }
+        return cqr;
 } /* end dasd_default_erp_action */
 
 /*
@@ -2141,26 +2572,21 @@
 	/* save ptr to original cqr */
 	cqr = erp;
 
-	/* set corresponding status to original cqr */
+	/* set corresponding status for original cqr */
 	if (success) {
-
-		check_then_set (&cqr->status, 
-                                CQR_STATUS_ERROR,
-				CQR_STATUS_DONE);
+                cqr->status = CQR_STATUS_DONE;
 	} else {
-
-		check_then_set (&cqr->status,
-				CQR_STATUS_ERROR, 
-                                CQR_STATUS_FAILED);
-
-                asm volatile ("STCK %0":"=m" (cqr->stopclk));
+                cqr->status  = CQR_STATUS_FAILED;
+                cqr->stopclk = get_clock ();
 	}
 
 	return cqr;
 
 } /* end default_erp_postaction */
 
-/* SECTION: The helpers of the struct file_operations */
+/********************************************************************************
+ * SECTION: The helpers of the struct file_operations 
+ ********************************************************************************/
 
 /*
  * function dasd_format
@@ -2175,38 +2601,43 @@
 {
 	int rc = 0;
 	int openct = atomic_read (&device->open_count);
+        ccw_req_t *req;
 
 	if (openct > 1) {
-		DASD_MESSAGE (KERN_WARNING, device, "%s",
-			      "dasd_format: device is open! expect errors.");
+
+		DEV_MESSAGE (KERN_WARNING, device, "%s",
+                             "dasd_format: device is open! "
+                             "expect errors.");
 	}
-	DASD_MESSAGE (KERN_INFO, device,
-		      "formatting units %d to %d (%d B blocks) flags %d",
-		      fdata->start_unit, 
-                      fdata->stop_unit,
-		      fdata->blksize, 
-                      fdata->intensity);
+
+	DBF_DEV_EVENT (DBF_NOTICE, device,
+                       "formatting units %d to %d (%d B blocks) flags %d",
+                       fdata->start_unit, 
+                       fdata->stop_unit,
+                       fdata->blksize, 
+                       fdata->intensity);
+
 	while ((!rc) && (fdata->start_unit <= fdata->stop_unit)) {
-                ccw_req_t *req;
-                dasd_format_fn_t ffn = device->discipline->format_device;
-		ffn = device->discipline->format_device;
-		if (ffn == NULL)
+
+		if (device->discipline->format_device == NULL)
 			break;
-		req = ffn (device, fdata);
+
+		req = device->discipline->format_device (device, fdata);
 		if (req == NULL) {
 			rc = -ENOMEM;
 			break;
 		}
-		if ((rc = dasd_sleep_on_req (req)) != 0) {
-			DASD_MESSAGE (KERN_WARNING, device,
-				      " Formatting of unit %d failed with rc = %d\n",
-				      fdata->start_unit, rc);
-			break;
-		} 
-		dasd_free_request (req, device);	/* request is no longer used */
-	        if ( signal_pending(current) ) {
-			rc = -ERESTARTSYS;
-			break;		
+
+                rc = dasd_sleep_on_req (req);
+                dasd_free_request (req, device); /* request is no longer used */
+
+                if ( rc ) {
+                        if (rc != -ERESTARTSYS )
+                               DEV_MESSAGE (KERN_WARNING, device,
+                                            " Formatting of unit %d failed"
+                                            " with rc = %d",
+                                            fdata->start_unit, rc);
+                       break;
                 }
 		fdata->start_unit++;
 	}
@@ -2258,6 +2689,9 @@
 	return 0;
 }
 
+/*
+ * handle the re-read partition table IOCTL (BLKRRPART)
+ */ 
 static int
 dasd_revalidate (dasd_device_t * device)
 {
@@ -2267,8 +2701,9 @@
 	int openct = atomic_read (&device->open_count);
 	int start = MINOR (kdev);
 	if (openct != 1) {
-		DASD_MESSAGE (KERN_WARNING, device, "%s",
-			      "BLKRRPART: device is open! expect errors.");
+
+		DEV_MESSAGE (KERN_WARNING, device, "%s",
+                             "BLKRRPART: device is open! expect errors.");
 	}
 	for (i = (1 << DASD_PARTN_BITS) - 1; i >= 0; i--) {
                 int major = device->major_info->gendisk.major;
@@ -2279,6 +2714,15 @@
         return rc;
 
 }
+
+/*
+ * function do_dasd_ioctl
+ * Implementation of the DASD API.
+ * Changes to the API should be binary compatible to privous versions
+ * of the user-space applications by means of any already existing tool 
+ * (e.g. dasdfmt) must work with the new kernel API.
+ */
+
 static int
 do_dasd_ioctl (struct inode *inp, /* unsigned */ int no, unsigned long data)
 {
@@ -2287,10 +2731,12 @@
 	major_info_t *major_info;
 
 	if (!device) {
-		printk (KERN_WARNING PRINTK_HEADER
-			"No device registered as device (%d:%d)\n",
-			MAJOR (inp->i_rdev), 
-                        MINOR (inp->i_rdev));
+
+		MESSAGE (KERN_WARNING,
+                         "No device registered as device (%d:%d)",
+                         MAJOR (inp->i_rdev), 
+                         MINOR (inp->i_rdev));
+
 		return -EINVAL;
 	}
 	if ((_IOC_DIR (no) != _IOC_NONE) && (data == 0)) {
